local AddonName, BoB = ...

BoB.NumString = function( number )
	local vartype = type( number )
	if vartype == "string" then 
		number = tonumber( number )
	elseif vartype == "number" then
		--
	else
		return number
	end
	
	local ones = { "one", "two", "three", "four", "five", "six", "seven", "eight", "nine", "ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen" }
	local tens =  {"teen", "twenty", "thirty", "fourty", "fifty", "sixty", "seventy", "eighty", "ninety"}
	
	if number >= 1 and number <= 15 then
		return ones[number]
	elseif number > 99 then
		return number
	else
		local numHigh = math.floor(number / 10)
		local numLow = number - (numHigh * 10)
		if number < 20 then
			return ( ones[numLow]..tens[numHigh] )
		elseif number / 10 == math.floor( number / 10) then
			return tens[numHigh]
		else
			return (tens[numHigh].." "..ones[numLow])
		end
	end
end


BoB.Frame = CreateFrame("Frame")
local e = 0
local current = 99
locan chan = "GUILD"
local run = false
local delay = 10
local currentdelay = 0

BoB.Frame:SetScript("OnUpdate", function(self, elapsed)
	if not(run) or current < 0 then return end
	e = e + elapsed
	currentdelay = currentdelay + elapsed
	if e < 1/5 then
		return
	end
	e = 0
	if currentdelay < delay then
		return
	end
	currentdelay = 0
	
	local msg
	
	if current == 2 then
		msg = "two bottles of beer on the wall, two bottles of beer.    Take one down and pass it around, one bottle of beer on the wall."
	elseif current == 1 then
		msg = "one bottle of beer on the wall, one bottle of beer.    Take one down and pass it around, no more bottles of beer on the wall."
	elseif current == 0 then
		msg = "No more bottles of beer on the wall, no more bottles of beer.    Go to the store and buy some more, nintynine bottles of beer on the wall."
		run = false
	else
		msg = BoB.NumString( current ).." bottles of beer on the wall, "..BoB.NumString( current ).." bottles of beer.    Take one down and pass it around, "..BoB.NumString(current - 1).." bottles of beer on the wall."
	end
	
	msg = string.upper(string.sub(msg, 1, 1)) .. string.sub(msg, 2)
	
	SendChatMessage( msg, chan )
	current = current - 1
end)
	
SLASH_BOB1 = "/bob"
SlashCmdList["BOB"] = function(msg)
	local cmd,arg = string.split(" ", msg)
	cmd = cmd:lower()
	
	if cmd == "current" then
		if arg then 
			current = tonumber(arg)
		end
		print( "99 Bottles Of Beer    Current Beer is "..current )
		return
	end
	
	if cmd == "run" then
		print("99 Bottles Of Beer:    Drinking 1 of "..current.." beers")
		run = true
		return
	end
	
	if cmd == "stop" then
		print("99 Bottles Of Beer:    Stopping at "..current.." beers")
		run = false
		return
	end
	
	if cmd == "delay" then
		local num = tonumber( arg )
		if num and num > 0 and num < 101 then
			delay = num
		end
		print("99 Bottles Of Beer:    Time between beers is "..delay.." seconds")
		return
	end
	
	if cmd == "chan" then
		if arg then
			chan = arg
		end
		print("99 Bottles Of Beer:    Drinking Channel is: "..chan)
		return
	end
	
	print("99 Bottles of Beer")
	print("/bob cmd")
	print("cmd = current   displays/ sets number of beers 1 - 99 (99 default)")
	print("cmd = run   runs the addon")
	print("cmd = stop   stops the adon")
	print("cmd = delay    how long between beers(1 - 100 seconds)")
	print("cmd = chan    what channel to serve beers in (GUILD is default  (SendChatMessage format))")
	return
end